/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x10240a, CODE_FOR_extendqihi2 },
  { 0x10240b, CODE_FOR_extendqisi2 },
  { 0x10240c, CODE_FOR_extendqidi2 },
  { 0x10280b, CODE_FOR_extendhisi2 },
  { 0x10280c, CODE_FOR_extendhidi2 },
  { 0x102c0c, CODE_FOR_extendsidi2 },
  { 0x108021, CODE_FOR_extendsfdf2 },
  { 0x203009, CODE_FOR_truncdiqi2 },
  { 0x20300a, CODE_FOR_truncdihi2 },
  { 0x20300b, CODE_FOR_truncdisi2 },
  { 0x208420, CODE_FOR_truncdfsf2 },
  { 0x30240a, CODE_FOR_zero_extendqihi2 },
  { 0x30240b, CODE_FOR_zero_extendqisi2 },
  { 0x30240c, CODE_FOR_zero_extendqidi2 },
  { 0x30280b, CODE_FOR_zero_extendhisi2 },
  { 0x30280c, CODE_FOR_zero_extendhidi2 },
  { 0x302c0c, CODE_FOR_zero_extendsidi2 },
  { 0x602c20, CODE_FOR_floatsisf2 },
  { 0x602c21, CODE_FOR_floatsidf2 },
  { 0x603020, CODE_FOR_floatdisf2 },
  { 0x603021, CODE_FOR_floatdidf2 },
  { 0x60d442, CODE_FOR_floatv4siv4sf2 },
  { 0x60d843, CODE_FOR_floatv2div2df2 },
  { 0x70d442, CODE_FOR_floatunsv4siv4sf2 },
  { 0x70d843, CODE_FOR_floatunsv2div2df2 },
  { 0x120800b, CODE_FOR_fix_truncsfsi2 },
  { 0x120800c, CODE_FOR_fix_truncsfdi2 },
  { 0x120840b, CODE_FOR_fix_truncdfsi2 },
  { 0x120840c, CODE_FOR_fix_truncdfdi2 },
  { 0x1210835, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x1210c36, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x130800b, CODE_FOR_fixuns_truncsfsi2 },
  { 0x130800c, CODE_FOR_fixuns_truncsfdi2 },
  { 0x130840b, CODE_FOR_fixuns_truncdfsi2 },
  { 0x130840c, CODE_FOR_fixuns_truncdfdi2 },
  { 0x1310835, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x1310c36, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x1402c0c, CODE_FOR_mulsidi3 },
  { 0x140300d, CODE_FOR_mulditi3 },
  { 0x1502c0c, CODE_FOR_umulsidi3 },
  { 0x150300d, CODE_FOR_umulditi3 },
  { 0x1702c0c, CODE_FOR_maddsidi4 },
  { 0x1802c0c, CODE_FOR_umaddsidi4 },
  { 0x1904011, CODE_FOR_ssmaddsqdq4 },
  { 0x1b02c0c, CODE_FOR_msubsidi4 },
  { 0x1c02c0c, CODE_FOR_umsubsidi4 },
  { 0x1d04011, CODE_FOR_ssmsubsqdq4 },
  { 0x270cc33, CODE_FOR_vcond_mask_v16qiv16qi },
  { 0x270cc34, CODE_FOR_vcond_mask_v8hiv16qi },
  { 0x270cc35, CODE_FOR_vcond_mask_v4siv16qi },
  { 0x270cc36, CODE_FOR_vcond_mask_v2div16qi },
  { 0x270cc42, CODE_FOR_vcond_mask_v4sfv16qi },
  { 0x270cc43, CODE_FOR_vcond_mask_v2dfv16qi },
  { 0x270d033, CODE_FOR_vcond_mask_v16qiv8hi },
  { 0x270d034, CODE_FOR_vcond_mask_v8hiv8hi },
  { 0x270d035, CODE_FOR_vcond_mask_v4siv8hi },
  { 0x270d036, CODE_FOR_vcond_mask_v2div8hi },
  { 0x270d042, CODE_FOR_vcond_mask_v4sfv8hi },
  { 0x270d043, CODE_FOR_vcond_mask_v2dfv8hi },
  { 0x270d433, CODE_FOR_vcond_mask_v16qiv4si },
  { 0x270d434, CODE_FOR_vcond_mask_v8hiv4si },
  { 0x270d435, CODE_FOR_vcond_mask_v4siv4si },
  { 0x270d436, CODE_FOR_vcond_mask_v2div4si },
  { 0x270d442, CODE_FOR_vcond_mask_v4sfv4si },
  { 0x270d443, CODE_FOR_vcond_mask_v2dfv4si },
  { 0x270d833, CODE_FOR_vcond_mask_v16qiv2di },
  { 0x270d834, CODE_FOR_vcond_mask_v8hiv2di },
  { 0x270d835, CODE_FOR_vcond_mask_v4siv2di },
  { 0x270d836, CODE_FOR_vcond_mask_v2div2di },
  { 0x270d842, CODE_FOR_vcond_mask_v4sfv2di },
  { 0x270d843, CODE_FOR_vcond_mask_v2dfv2di },
  { 0x280cc33, CODE_FOR_vec_cmpv16qiv16qi },
  { 0x280d034, CODE_FOR_vec_cmpv8hiv8hi },
  { 0x280d435, CODE_FOR_vec_cmpv4siv4si },
  { 0x280d442, CODE_FOR_vec_cmpv4sfv4si },
  { 0x280d836, CODE_FOR_vec_cmpv2div2di },
  { 0x280d843, CODE_FOR_vec_cmpv2dfv2di },
  { 0x290cc33, CODE_FOR_vec_cmpuv16qiv16qi },
  { 0x290d034, CODE_FOR_vec_cmpuv8hiv8hi },
  { 0x290d435, CODE_FOR_vec_cmpuv4siv4si },
  { 0x290d836, CODE_FOR_vec_cmpuv2div2di },
  { 0x3502433, CODE_FOR_vec_extractv16qiqi },
  { 0x3502834, CODE_FOR_vec_extractv8hihi },
  { 0x3502c35, CODE_FOR_vec_extractv4sisi },
  { 0x3503036, CODE_FOR_vec_extractv2didi },
  { 0x3508041, CODE_FOR_vec_extractv2sfsf },
  { 0x3508042, CODE_FOR_vec_extractv4sfsf },
  { 0x3508443, CODE_FOR_vec_extractv2dfdf },
  { 0x3602430, CODE_FOR_vec_initv8qiqi },
  { 0x3602433, CODE_FOR_vec_initv16qiqi },
  { 0x3602831, CODE_FOR_vec_initv4hihi },
  { 0x3602834, CODE_FOR_vec_initv8hihi },
  { 0x3602c32, CODE_FOR_vec_initv2sisi },
  { 0x3602c35, CODE_FOR_vec_initv4sisi },
  { 0x3603036, CODE_FOR_vec_initv2didi },
  { 0x3608041, CODE_FOR_vec_initv2sfsf },
  { 0x3608042, CODE_FOR_vec_initv4sfsf },
  { 0x3608443, CODE_FOR_vec_initv2dfdf },
  { 0x370c432, CODE_FOR_sdot_prodv2siv4hi },
  { 0x3b0000b, CODE_FOR_addsi3 },
  { 0x3b0000c, CODE_FOR_adddi3 },
  { 0x3b0000e, CODE_FOR_addqq3 },
  { 0x3b0000f, CODE_FOR_addhq3 },
  { 0x3b00010, CODE_FOR_addsq3 },
  { 0x3b00011, CODE_FOR_adddq3 },
  { 0x3b00013, CODE_FOR_adduqq3 },
  { 0x3b00014, CODE_FOR_adduhq3 },
  { 0x3b00015, CODE_FOR_addusq3 },
  { 0x3b00016, CODE_FOR_addudq3 },
  { 0x3b00018, CODE_FOR_addha3 },
  { 0x3b00019, CODE_FOR_addsa3 },
  { 0x3b0001a, CODE_FOR_addda3 },
  { 0x3b0001c, CODE_FOR_adduha3 },
  { 0x3b0001d, CODE_FOR_addusa3 },
  { 0x3b0001e, CODE_FOR_adduda3 },
  { 0x3b00020, CODE_FOR_addsf3 },
  { 0x3b00021, CODE_FOR_adddf3 },
  { 0x3b0002e, CODE_FOR_addv4qi3 },
  { 0x3b0002f, CODE_FOR_addv2hi3 },
  { 0x3b00030, CODE_FOR_addv8qi3 },
  { 0x3b00031, CODE_FOR_addv4hi3 },
  { 0x3b00032, CODE_FOR_addv2si3 },
  { 0x3b00033, CODE_FOR_addv16qi3 },
  { 0x3b00034, CODE_FOR_addv8hi3 },
  { 0x3b00035, CODE_FOR_addv4si3 },
  { 0x3b00036, CODE_FOR_addv2di3 },
  { 0x3b00041, CODE_FOR_addv2sf3 },
  { 0x3b00042, CODE_FOR_addv4sf3 },
  { 0x3b00043, CODE_FOR_addv2df3 },
  { 0x3d0000f, CODE_FOR_ssaddhq3 },
  { 0x3d00010, CODE_FOR_ssaddsq3 },
  { 0x3d00018, CODE_FOR_ssaddha3 },
  { 0x3d00019, CODE_FOR_ssaddsa3 },
  { 0x3d00030, CODE_FOR_ssaddv8qi3 },
  { 0x3d00031, CODE_FOR_ssaddv4hi3 },
  { 0x3d00033, CODE_FOR_ssaddv16qi3 },
  { 0x3d00034, CODE_FOR_ssaddv8hi3 },
  { 0x3d00035, CODE_FOR_ssaddv4si3 },
  { 0x3d00036, CODE_FOR_ssaddv2di3 },
  { 0x3d0003c, CODE_FOR_ssaddv2hq3 },
  { 0x3d0003f, CODE_FOR_ssaddv2ha3 },
  { 0x3e00013, CODE_FOR_usadduqq3 },
  { 0x3e00014, CODE_FOR_usadduhq3 },
  { 0x3e0001c, CODE_FOR_usadduha3 },
  { 0x3e00030, CODE_FOR_usaddv8qi3 },
  { 0x3e00031, CODE_FOR_usaddv4hi3 },
  { 0x3e00033, CODE_FOR_usaddv16qi3 },
  { 0x3e00034, CODE_FOR_usaddv8hi3 },
  { 0x3e00035, CODE_FOR_usaddv4si3 },
  { 0x3e00036, CODE_FOR_usaddv2di3 },
  { 0x3e0003d, CODE_FOR_usaddv4uqq3 },
  { 0x3e0003e, CODE_FOR_usaddv2uhq3 },
  { 0x3e00040, CODE_FOR_usaddv2uha3 },
  { 0x3f0000b, CODE_FOR_subsi3 },
  { 0x3f0000c, CODE_FOR_subdi3 },
  { 0x3f0000e, CODE_FOR_subqq3 },
  { 0x3f0000f, CODE_FOR_subhq3 },
  { 0x3f00010, CODE_FOR_subsq3 },
  { 0x3f00011, CODE_FOR_subdq3 },
  { 0x3f00013, CODE_FOR_subuqq3 },
  { 0x3f00014, CODE_FOR_subuhq3 },
  { 0x3f00015, CODE_FOR_subusq3 },
  { 0x3f00016, CODE_FOR_subudq3 },
  { 0x3f00018, CODE_FOR_subha3 },
  { 0x3f00019, CODE_FOR_subsa3 },
  { 0x3f0001a, CODE_FOR_subda3 },
  { 0x3f0001c, CODE_FOR_subuha3 },
  { 0x3f0001d, CODE_FOR_subusa3 },
  { 0x3f0001e, CODE_FOR_subuda3 },
  { 0x3f00020, CODE_FOR_subsf3 },
  { 0x3f00021, CODE_FOR_subdf3 },
  { 0x3f0002e, CODE_FOR_subv4qi3 },
  { 0x3f0002f, CODE_FOR_subv2hi3 },
  { 0x3f00030, CODE_FOR_subv8qi3 },
  { 0x3f00031, CODE_FOR_subv4hi3 },
  { 0x3f00032, CODE_FOR_subv2si3 },
  { 0x3f00033, CODE_FOR_subv16qi3 },
  { 0x3f00034, CODE_FOR_subv8hi3 },
  { 0x3f00035, CODE_FOR_subv4si3 },
  { 0x3f00036, CODE_FOR_subv2di3 },
  { 0x3f00041, CODE_FOR_subv2sf3 },
  { 0x3f00042, CODE_FOR_subv4sf3 },
  { 0x3f00043, CODE_FOR_subv2df3 },
  { 0x410000f, CODE_FOR_sssubhq3 },
  { 0x4100010, CODE_FOR_sssubsq3 },
  { 0x4100018, CODE_FOR_sssubha3 },
  { 0x4100019, CODE_FOR_sssubsa3 },
  { 0x4100030, CODE_FOR_sssubv8qi3 },
  { 0x4100031, CODE_FOR_sssubv4hi3 },
  { 0x410003c, CODE_FOR_sssubv2hq3 },
  { 0x410003f, CODE_FOR_sssubv2ha3 },
  { 0x4200013, CODE_FOR_ussubuqq3 },
  { 0x4200014, CODE_FOR_ussubuhq3 },
  { 0x420001c, CODE_FOR_ussubuha3 },
  { 0x4200030, CODE_FOR_ussubv8qi3 },
  { 0x4200031, CODE_FOR_ussubv4hi3 },
  { 0x420003d, CODE_FOR_ussubv4uqq3 },
  { 0x420003e, CODE_FOR_ussubv2uhq3 },
  { 0x4200040, CODE_FOR_ussubv2uha3 },
  { 0x430000b, CODE_FOR_mulsi3 },
  { 0x430000c, CODE_FOR_muldi3 },
  { 0x4300020, CODE_FOR_mulsf3 },
  { 0x4300021, CODE_FOR_muldf3 },
  { 0x430002f, CODE_FOR_mulv2hi3 },
  { 0x4300031, CODE_FOR_mulv4hi3 },
  { 0x4300033, CODE_FOR_mulv16qi3 },
  { 0x4300034, CODE_FOR_mulv8hi3 },
  { 0x4300035, CODE_FOR_mulv4si3 },
  { 0x4300036, CODE_FOR_mulv2di3 },
  { 0x4300041, CODE_FOR_mulv2sf3 },
  { 0x4300042, CODE_FOR_mulv4sf3 },
  { 0x4300043, CODE_FOR_mulv2df3 },
  { 0x450000f, CODE_FOR_ssmulhq3 },
  { 0x4500010, CODE_FOR_ssmulsq3 },
  { 0x450003c, CODE_FOR_ssmulv2hq3 },
  { 0x470000b, CODE_FOR_divsi3 },
  { 0x470000c, CODE_FOR_divdi3 },
  { 0x4700020, CODE_FOR_divsf3 },
  { 0x4700021, CODE_FOR_divdf3 },
  { 0x4700033, CODE_FOR_divv16qi3 },
  { 0x4700034, CODE_FOR_divv8hi3 },
  { 0x4700035, CODE_FOR_divv4si3 },
  { 0x4700036, CODE_FOR_divv2di3 },
  { 0x4700041, CODE_FOR_divv2sf3 },
  { 0x4700042, CODE_FOR_divv4sf3 },
  { 0x4700043, CODE_FOR_divv2df3 },
  { 0x4a0000b, CODE_FOR_udivsi3 },
  { 0x4a0000c, CODE_FOR_udivdi3 },
  { 0x4a00033, CODE_FOR_udivv16qi3 },
  { 0x4a00034, CODE_FOR_udivv8hi3 },
  { 0x4a00035, CODE_FOR_udivv4si3 },
  { 0x4a00036, CODE_FOR_udivv2di3 },
  { 0x4c0000b, CODE_FOR_divmodsi4 },
  { 0x4c0000c, CODE_FOR_divmoddi4 },
  { 0x4d0000b, CODE_FOR_udivmodsi4 },
  { 0x4d0000c, CODE_FOR_udivmoddi4 },
  { 0x4e0000b, CODE_FOR_modsi3 },
  { 0x4e0000c, CODE_FOR_moddi3 },
  { 0x4e00033, CODE_FOR_modv16qi3 },
  { 0x4e00034, CODE_FOR_modv8hi3 },
  { 0x4e00035, CODE_FOR_modv4si3 },
  { 0x4e00036, CODE_FOR_modv2di3 },
  { 0x4f0000b, CODE_FOR_umodsi3 },
  { 0x4f0000c, CODE_FOR_umoddi3 },
  { 0x4f00033, CODE_FOR_umodv16qi3 },
  { 0x4f00034, CODE_FOR_umodv8hi3 },
  { 0x4f00035, CODE_FOR_umodv4si3 },
  { 0x4f00036, CODE_FOR_umodv2di3 },
  { 0x510000b, CODE_FOR_andsi3 },
  { 0x510000c, CODE_FOR_anddi3 },
  { 0x5100030, CODE_FOR_andv8qi3 },
  { 0x5100031, CODE_FOR_andv4hi3 },
  { 0x5100032, CODE_FOR_andv2si3 },
  { 0x5100033, CODE_FOR_andv16qi3 },
  { 0x5100034, CODE_FOR_andv8hi3 },
  { 0x5100035, CODE_FOR_andv4si3 },
  { 0x5100036, CODE_FOR_andv2di3 },
  { 0x520000b, CODE_FOR_iorsi3 },
  { 0x520000c, CODE_FOR_iordi3 },
  { 0x5200030, CODE_FOR_iorv8qi3 },
  { 0x5200031, CODE_FOR_iorv4hi3 },
  { 0x5200032, CODE_FOR_iorv2si3 },
  { 0x5200033, CODE_FOR_iorv16qi3 },
  { 0x5200034, CODE_FOR_iorv8hi3 },
  { 0x5200035, CODE_FOR_iorv4si3 },
  { 0x5200036, CODE_FOR_iorv2di3 },
  { 0x530000b, CODE_FOR_xorsi3 },
  { 0x530000c, CODE_FOR_xordi3 },
  { 0x5300030, CODE_FOR_xorv8qi3 },
  { 0x5300031, CODE_FOR_xorv4hi3 },
  { 0x5300032, CODE_FOR_xorv2si3 },
  { 0x5300033, CODE_FOR_xorv16qi3 },
  { 0x5300034, CODE_FOR_xorv8hi3 },
  { 0x5300035, CODE_FOR_xorv4si3 },
  { 0x5300036, CODE_FOR_xorv2di3 },
  { 0x540000b, CODE_FOR_ashlsi3 },
  { 0x540000c, CODE_FOR_ashldi3 },
  { 0x5400031, CODE_FOR_ashlv4hi3 },
  { 0x5400032, CODE_FOR_ashlv2si3 },
  { 0x570000b, CODE_FOR_ashrsi3 },
  { 0x570000c, CODE_FOR_ashrdi3 },
  { 0x5700031, CODE_FOR_ashrv4hi3 },
  { 0x5700032, CODE_FOR_ashrv2si3 },
  { 0x580000b, CODE_FOR_lshrsi3 },
  { 0x580000c, CODE_FOR_lshrdi3 },
  { 0x5800031, CODE_FOR_lshrv4hi3 },
  { 0x5800032, CODE_FOR_lshrv2si3 },
  { 0x5a0000b, CODE_FOR_rotrsi3 },
  { 0x5a0000c, CODE_FOR_rotrdi3 },
  { 0x5b00033, CODE_FOR_vashlv16qi3 },
  { 0x5b00034, CODE_FOR_vashlv8hi3 },
  { 0x5b00035, CODE_FOR_vashlv4si3 },
  { 0x5b00036, CODE_FOR_vashlv2di3 },
  { 0x5c00033, CODE_FOR_vashrv16qi3 },
  { 0x5c00034, CODE_FOR_vashrv8hi3 },
  { 0x5c00035, CODE_FOR_vashrv4si3 },
  { 0x5c00036, CODE_FOR_vashrv2di3 },
  { 0x5d00033, CODE_FOR_vlshrv16qi3 },
  { 0x5d00034, CODE_FOR_vlshrv8hi3 },
  { 0x5d00035, CODE_FOR_vlshrv4si3 },
  { 0x5d00036, CODE_FOR_vlshrv2di3 },
  { 0x6000020, CODE_FOR_sminsf3 },
  { 0x6000021, CODE_FOR_smindf3 },
  { 0x6000030, CODE_FOR_sminv8qi3 },
  { 0x6000031, CODE_FOR_sminv4hi3 },
  { 0x6000032, CODE_FOR_sminv2si3 },
  { 0x6000033, CODE_FOR_sminv16qi3 },
  { 0x6000034, CODE_FOR_sminv8hi3 },
  { 0x6000035, CODE_FOR_sminv4si3 },
  { 0x6000036, CODE_FOR_sminv2di3 },
  { 0x6000041, CODE_FOR_sminv2sf3 },
  { 0x6000042, CODE_FOR_sminv4sf3 },
  { 0x6000043, CODE_FOR_sminv2df3 },
  { 0x6100020, CODE_FOR_smaxsf3 },
  { 0x6100021, CODE_FOR_smaxdf3 },
  { 0x6100030, CODE_FOR_smaxv8qi3 },
  { 0x6100031, CODE_FOR_smaxv4hi3 },
  { 0x6100032, CODE_FOR_smaxv2si3 },
  { 0x6100033, CODE_FOR_smaxv16qi3 },
  { 0x6100034, CODE_FOR_smaxv8hi3 },
  { 0x6100035, CODE_FOR_smaxv4si3 },
  { 0x6100036, CODE_FOR_smaxv2di3 },
  { 0x6100041, CODE_FOR_smaxv2sf3 },
  { 0x6100042, CODE_FOR_smaxv4sf3 },
  { 0x6100043, CODE_FOR_smaxv2df3 },
  { 0x6200030, CODE_FOR_uminv8qi3 },
  { 0x6200033, CODE_FOR_uminv16qi3 },
  { 0x6200034, CODE_FOR_uminv8hi3 },
  { 0x6200035, CODE_FOR_uminv4si3 },
  { 0x6200036, CODE_FOR_uminv2di3 },
  { 0x6300030, CODE_FOR_umaxv8qi3 },
  { 0x6300033, CODE_FOR_umaxv16qi3 },
  { 0x6300034, CODE_FOR_umaxv8hi3 },
  { 0x6300035, CODE_FOR_umaxv4si3 },
  { 0x6300036, CODE_FOR_umaxv2di3 },
  { 0x640000b, CODE_FOR_negsi2 },
  { 0x640000c, CODE_FOR_negdi2 },
  { 0x6400020, CODE_FOR_negsf2 },
  { 0x6400021, CODE_FOR_negdf2 },
  { 0x6400033, CODE_FOR_negv16qi2 },
  { 0x6400034, CODE_FOR_negv8hi2 },
  { 0x6400035, CODE_FOR_negv4si2 },
  { 0x6400036, CODE_FOR_negv2di2 },
  { 0x6400041, CODE_FOR_negv2sf2 },
  { 0x6400042, CODE_FOR_negv4sf2 },
  { 0x6400043, CODE_FOR_negv2df2 },
  { 0x6800020, CODE_FOR_abssf2 },
  { 0x6800021, CODE_FOR_absdf2 },
  { 0x6800033, CODE_FOR_absv16qi2 },
  { 0x6800034, CODE_FOR_absv8hi2 },
  { 0x6800035, CODE_FOR_absv4si2 },
  { 0x6800036, CODE_FOR_absv2di2 },
  { 0x6800041, CODE_FOR_absv2sf2 },
  { 0x6a0000b, CODE_FOR_one_cmplsi2 },
  { 0x6a0000c, CODE_FOR_one_cmpldi2 },
  { 0x6a00030, CODE_FOR_one_cmplv8qi2 },
  { 0x6a00031, CODE_FOR_one_cmplv4hi2 },
  { 0x6a00032, CODE_FOR_one_cmplv2si2 },
  { 0x6a00033, CODE_FOR_one_cmplv16qi2 },
  { 0x6a00034, CODE_FOR_one_cmplv8hi2 },
  { 0x6a00035, CODE_FOR_one_cmplv4si2 },
  { 0x6a00036, CODE_FOR_one_cmplv2di2 },
  { 0x6b0000a, CODE_FOR_bswaphi2 },
  { 0x6b0000b, CODE_FOR_bswapsi2 },
  { 0x6b0000c, CODE_FOR_bswapdi2 },
  { 0x6d0000b, CODE_FOR_clzsi2 },
  { 0x6d0000c, CODE_FOR_clzdi2 },
  { 0x6d00033, CODE_FOR_clzv16qi2 },
  { 0x6d00034, CODE_FOR_clzv8hi2 },
  { 0x6d00035, CODE_FOR_clzv4si2 },
  { 0x6d00036, CODE_FOR_clzv2di2 },
  { 0x6e0000b, CODE_FOR_ctzsi2 },
  { 0x6e0000c, CODE_FOR_ctzdi2 },
  { 0x700000b, CODE_FOR_popcountsi2 },
  { 0x700000c, CODE_FOR_popcountdi2 },
  { 0x7000033, CODE_FOR_popcountv16qi2 },
  { 0x7000034, CODE_FOR_popcountv8hi2 },
  { 0x7000035, CODE_FOR_popcountv4si2 },
  { 0x7000036, CODE_FOR_popcountv2di2 },
  { 0x7c00020, CODE_FOR_sqrtsf2 },
  { 0x7c00021, CODE_FOR_sqrtdf2 },
  { 0x7c00041, CODE_FOR_sqrtv2sf2 },
  { 0x7c00042, CODE_FOR_sqrtv4sf2 },
  { 0x7c00043, CODE_FOR_sqrtv2df2 },
  { 0x7d00009, CODE_FOR_sync_old_addqi },
  { 0x7d0000a, CODE_FOR_sync_old_addhi },
  { 0x7d0000b, CODE_FOR_sync_old_addsi },
  { 0x7d0000c, CODE_FOR_sync_old_adddi },
  { 0x7e00009, CODE_FOR_sync_old_subqi },
  { 0x7e0000a, CODE_FOR_sync_old_subhi },
  { 0x7e0000b, CODE_FOR_sync_old_subsi },
  { 0x7e0000c, CODE_FOR_sync_old_subdi },
  { 0x7f00009, CODE_FOR_sync_old_iorqi },
  { 0x7f0000a, CODE_FOR_sync_old_iorhi },
  { 0x7f0000b, CODE_FOR_sync_old_iorsi },
  { 0x7f0000c, CODE_FOR_sync_old_iordi },
  { 0x8000009, CODE_FOR_sync_old_andqi },
  { 0x800000a, CODE_FOR_sync_old_andhi },
  { 0x800000b, CODE_FOR_sync_old_andsi },
  { 0x800000c, CODE_FOR_sync_old_anddi },
  { 0x8100009, CODE_FOR_sync_old_xorqi },
  { 0x810000a, CODE_FOR_sync_old_xorhi },
  { 0x810000b, CODE_FOR_sync_old_xorsi },
  { 0x810000c, CODE_FOR_sync_old_xordi },
  { 0x8200009, CODE_FOR_sync_old_nandqi },
  { 0x820000a, CODE_FOR_sync_old_nandhi },
  { 0x820000b, CODE_FOR_sync_old_nandsi },
  { 0x820000c, CODE_FOR_sync_old_nanddi },
  { 0x8300009, CODE_FOR_sync_new_addqi },
  { 0x830000a, CODE_FOR_sync_new_addhi },
  { 0x830000b, CODE_FOR_sync_new_addsi },
  { 0x830000c, CODE_FOR_sync_new_adddi },
  { 0x8400009, CODE_FOR_sync_new_subqi },
  { 0x840000a, CODE_FOR_sync_new_subhi },
  { 0x840000b, CODE_FOR_sync_new_subsi },
  { 0x840000c, CODE_FOR_sync_new_subdi },
  { 0x8500009, CODE_FOR_sync_new_iorqi },
  { 0x850000a, CODE_FOR_sync_new_iorhi },
  { 0x850000b, CODE_FOR_sync_new_iorsi },
  { 0x850000c, CODE_FOR_sync_new_iordi },
  { 0x8600009, CODE_FOR_sync_new_andqi },
  { 0x860000a, CODE_FOR_sync_new_andhi },
  { 0x860000b, CODE_FOR_sync_new_andsi },
  { 0x860000c, CODE_FOR_sync_new_anddi },
  { 0x8700009, CODE_FOR_sync_new_xorqi },
  { 0x870000a, CODE_FOR_sync_new_xorhi },
  { 0x870000b, CODE_FOR_sync_new_xorsi },
  { 0x870000c, CODE_FOR_sync_new_xordi },
  { 0x8800009, CODE_FOR_sync_new_nandqi },
  { 0x880000a, CODE_FOR_sync_new_nandhi },
  { 0x880000b, CODE_FOR_sync_new_nandsi },
  { 0x880000c, CODE_FOR_sync_new_nanddi },
  { 0x8900009, CODE_FOR_sync_compare_and_swapqi },
  { 0x890000a, CODE_FOR_sync_compare_and_swaphi },
  { 0x890000b, CODE_FOR_sync_compare_and_swapsi },
  { 0x890000c, CODE_FOR_sync_compare_and_swapdi },
  { 0x8a00009, CODE_FOR_sync_lock_test_and_setqi },
  { 0x8a0000a, CODE_FOR_sync_lock_test_and_sethi },
  { 0x8a0000b, CODE_FOR_sync_lock_test_and_setsi },
  { 0x8a0000c, CODE_FOR_sync_lock_test_and_setdi },
  { 0x8b00007, CODE_FOR_movccf },
  { 0x8b00009, CODE_FOR_movqi },
  { 0x8b0000a, CODE_FOR_movhi },
  { 0x8b0000b, CODE_FOR_movsi },
  { 0x8b0000c, CODE_FOR_movdi },
  { 0x8b0000d, CODE_FOR_movti },
  { 0x8b00020, CODE_FOR_movsf },
  { 0x8b00021, CODE_FOR_movdf },
  { 0x8b00022, CODE_FOR_movtf },
  { 0x8b0002e, CODE_FOR_movv4qi },
  { 0x8b0002f, CODE_FOR_movv2hi },
  { 0x8b00030, CODE_FOR_movv8qi },
  { 0x8b00031, CODE_FOR_movv4hi },
  { 0x8b00032, CODE_FOR_movv2si },
  { 0x8b00033, CODE_FOR_movv16qi },
  { 0x8b00034, CODE_FOR_movv8hi },
  { 0x8b00035, CODE_FOR_movv4si },
  { 0x8b00036, CODE_FOR_movv2di },
  { 0x8b0003b, CODE_FOR_movv4qq },
  { 0x8b0003c, CODE_FOR_movv2hq },
  { 0x8b0003d, CODE_FOR_movv4uqq },
  { 0x8b0003e, CODE_FOR_movv2uhq },
  { 0x8b0003f, CODE_FOR_movv2ha },
  { 0x8b00040, CODE_FOR_movv2uha },
  { 0x8b00041, CODE_FOR_movv2sf },
  { 0x8b00042, CODE_FOR_movv4sf },
  { 0x8b00043, CODE_FOR_movv2df },
  { 0x8d0000a, CODE_FOR_movmisalignhi },
  { 0x8d0000b, CODE_FOR_movmisalignsi },
  { 0x8d00020, CODE_FOR_movmisalignsf },
  { 0x8d00021, CODE_FOR_movmisaligndf },
  { 0x8d00033, CODE_FOR_movmisalignv16qi },
  { 0x8d00034, CODE_FOR_movmisalignv8hi },
  { 0x8d00035, CODE_FOR_movmisalignv4si },
  { 0x8d00036, CODE_FOR_movmisalignv2di },
  { 0x8d00042, CODE_FOR_movmisalignv4sf },
  { 0x8d00043, CODE_FOR_movmisalignv2df },
  { 0x8f0000b, CODE_FOR_insvsi },
  { 0x8f0000c, CODE_FOR_insvdi },
  { 0x900000b, CODE_FOR_extvsi },
  { 0x900000c, CODE_FOR_extvdi },
  { 0x910000b, CODE_FOR_extzvsi },
  { 0x910000c, CODE_FOR_extzvdi },
  { 0x920000b, CODE_FOR_insvmisalignsi },
  { 0x920000c, CODE_FOR_insvmisaligndi },
  { 0x930000b, CODE_FOR_extvmisalignsi },
  { 0x930000c, CODE_FOR_extvmisaligndi },
  { 0x940000b, CODE_FOR_extzvmisalignsi },
  { 0x940000c, CODE_FOR_extzvmisaligndi },
  { 0x980000b, CODE_FOR_cbranchsi4 },
  { 0x980000c, CODE_FOR_cbranchdi4 },
  { 0x9800020, CODE_FOR_cbranchsf4 },
  { 0x9800021, CODE_FOR_cbranchdf4 },
  { 0x9e0000b, CODE_FOR_movsicc },
  { 0x9e0000c, CODE_FOR_movdicc },
  { 0x9e00020, CODE_FOR_movsfcc },
  { 0x9e00021, CODE_FOR_movdfcc },
  { 0x9e00041, CODE_FOR_movv2sfcc },
  { 0xd50000b, CODE_FOR_cstoresi4 },
  { 0xd50000c, CODE_FOR_cstoredi4 },
  { 0xd60000b, CODE_FOR_ctrapsi4 },
  { 0xd60000c, CODE_FOR_ctrapdi4 },
  { 0xe20000b, CODE_FOR_smulsi3_highpart },
  { 0xe20000c, CODE_FOR_smuldi3_highpart },
  { 0xe200031, CODE_FOR_smulv4hi3_highpart },
  { 0xe30000b, CODE_FOR_umulsi3_highpart },
  { 0xe30000c, CODE_FOR_umuldi3_highpart },
  { 0xe300031, CODE_FOR_umulv4hi3_highpart },
  { 0xe70000b, CODE_FOR_cpymemsi },
  { 0xec00020, CODE_FOR_fmasf4 },
  { 0xec00021, CODE_FOR_fmadf4 },
  { 0xec00041, CODE_FOR_fmav2sf4 },
  { 0xec00042, CODE_FOR_fmav4sf4 },
  { 0xec00043, CODE_FOR_fmav2df4 },
  { 0xed00020, CODE_FOR_fmssf4 },
  { 0xed00021, CODE_FOR_fmsdf4 },
  { 0xed00041, CODE_FOR_fmsv2sf4 },
  { 0xee00020, CODE_FOR_fnmasf4 },
  { 0xee00021, CODE_FOR_fnmadf4 },
  { 0xee00041, CODE_FOR_fnmav2sf4 },
  { 0xee00042, CODE_FOR_fnmav4sf4 },
  { 0xee00043, CODE_FOR_fnmav2df4 },
  { 0xef00020, CODE_FOR_fnmssf4 },
  { 0xef00021, CODE_FOR_fnmsdf4 },
  { 0xef00041, CODE_FOR_fnmsv2sf4 },
  { 0xf000020, CODE_FOR_rintsf2 },
  { 0xf000021, CODE_FOR_rintdf2 },
  { 0x12900020, CODE_FOR_fmaxsf3 },
  { 0x12900021, CODE_FOR_fmaxdf3 },
  { 0x12a00020, CODE_FOR_fminsf3 },
  { 0x12a00021, CODE_FOR_fmindf3 },
  { 0x12d00030, CODE_FOR_reduc_smax_scal_v8qi },
  { 0x12d00031, CODE_FOR_reduc_smax_scal_v4hi },
  { 0x12d00032, CODE_FOR_reduc_smax_scal_v2si },
  { 0x12d00033, CODE_FOR_reduc_smax_scal_v16qi },
  { 0x12d00034, CODE_FOR_reduc_smax_scal_v8hi },
  { 0x12d00035, CODE_FOR_reduc_smax_scal_v4si },
  { 0x12d00036, CODE_FOR_reduc_smax_scal_v2di },
  { 0x12d00041, CODE_FOR_reduc_smax_scal_v2sf },
  { 0x12d00042, CODE_FOR_reduc_smax_scal_v4sf },
  { 0x12d00043, CODE_FOR_reduc_smax_scal_v2df },
  { 0x12e00030, CODE_FOR_reduc_smin_scal_v8qi },
  { 0x12e00031, CODE_FOR_reduc_smin_scal_v4hi },
  { 0x12e00032, CODE_FOR_reduc_smin_scal_v2si },
  { 0x12e00033, CODE_FOR_reduc_smin_scal_v16qi },
  { 0x12e00034, CODE_FOR_reduc_smin_scal_v8hi },
  { 0x12e00035, CODE_FOR_reduc_smin_scal_v4si },
  { 0x12e00036, CODE_FOR_reduc_smin_scal_v2di },
  { 0x12e00041, CODE_FOR_reduc_smin_scal_v2sf },
  { 0x12e00042, CODE_FOR_reduc_smin_scal_v4sf },
  { 0x12e00043, CODE_FOR_reduc_smin_scal_v2df },
  { 0x12f00030, CODE_FOR_reduc_plus_scal_v8qi },
  { 0x12f00031, CODE_FOR_reduc_plus_scal_v4hi },
  { 0x12f00032, CODE_FOR_reduc_plus_scal_v2si },
  { 0x12f00033, CODE_FOR_reduc_plus_scal_v16qi },
  { 0x12f00034, CODE_FOR_reduc_plus_scal_v8hi },
  { 0x12f00035, CODE_FOR_reduc_plus_scal_v4si },
  { 0x12f00036, CODE_FOR_reduc_plus_scal_v2di },
  { 0x12f00041, CODE_FOR_reduc_plus_scal_v2sf },
  { 0x12f00042, CODE_FOR_reduc_plus_scal_v4sf },
  { 0x12f00043, CODE_FOR_reduc_plus_scal_v2df },
  { 0x13000030, CODE_FOR_reduc_umax_scal_v8qi },
  { 0x13000033, CODE_FOR_reduc_umax_scal_v16qi },
  { 0x13000034, CODE_FOR_reduc_umax_scal_v8hi },
  { 0x13000035, CODE_FOR_reduc_umax_scal_v4si },
  { 0x13000036, CODE_FOR_reduc_umax_scal_v2di },
  { 0x13100030, CODE_FOR_reduc_umin_scal_v8qi },
  { 0x13100033, CODE_FOR_reduc_umin_scal_v16qi },
  { 0x13100034, CODE_FOR_reduc_umin_scal_v8hi },
  { 0x13100035, CODE_FOR_reduc_umin_scal_v4si },
  { 0x13100036, CODE_FOR_reduc_umin_scal_v2di },
  { 0x13200033, CODE_FOR_reduc_and_scal_v16qi },
  { 0x13200034, CODE_FOR_reduc_and_scal_v8hi },
  { 0x13200035, CODE_FOR_reduc_and_scal_v4si },
  { 0x13200036, CODE_FOR_reduc_and_scal_v2di },
  { 0x13300033, CODE_FOR_reduc_ior_scal_v16qi },
  { 0x13300034, CODE_FOR_reduc_ior_scal_v8hi },
  { 0x13300035, CODE_FOR_reduc_ior_scal_v4si },
  { 0x13300036, CODE_FOR_reduc_ior_scal_v2di },
  { 0x13400033, CODE_FOR_reduc_xor_scal_v16qi },
  { 0x13400034, CODE_FOR_reduc_xor_scal_v8hi },
  { 0x13400035, CODE_FOR_reduc_xor_scal_v4si },
  { 0x13400036, CODE_FOR_reduc_xor_scal_v2di },
  { 0x14b00031, CODE_FOR_vec_pack_ssat_v4hi },
  { 0x14b00032, CODE_FOR_vec_pack_ssat_v2si },
  { 0x14c00034, CODE_FOR_vec_pack_trunc_v8hi },
  { 0x14c00035, CODE_FOR_vec_pack_trunc_v4si },
  { 0x14c00036, CODE_FOR_vec_pack_trunc_v2di },
  { 0x14c00043, CODE_FOR_vec_pack_trunc_v2df },
  { 0x14f00031, CODE_FOR_vec_pack_usat_v4hi },
  { 0x15200033, CODE_FOR_vec_permv16qi },
  { 0x15200034, CODE_FOR_vec_permv8hi },
  { 0x15200035, CODE_FOR_vec_permv4si },
  { 0x15200036, CODE_FOR_vec_permv2di },
  { 0x15200042, CODE_FOR_vec_permv4sf },
  { 0x15200043, CODE_FOR_vec_permv2df },
  { 0x15400031, CODE_FOR_vec_setv4hi },
  { 0x15400033, CODE_FOR_vec_setv16qi },
  { 0x15400034, CODE_FOR_vec_setv8hi },
  { 0x15400035, CODE_FOR_vec_setv4si },
  { 0x15400036, CODE_FOR_vec_setv2di },
  { 0x15400041, CODE_FOR_vec_setv2sf },
  { 0x15400042, CODE_FOR_vec_setv4sf },
  { 0x15400043, CODE_FOR_vec_setv2df },
  { 0x1550000c, CODE_FOR_vec_shl_di },
  { 0x15500030, CODE_FOR_vec_shl_v8qi },
  { 0x15500031, CODE_FOR_vec_shl_v4hi },
  { 0x15500032, CODE_FOR_vec_shl_v2si },
  { 0x1560000c, CODE_FOR_vec_shr_di },
  { 0x15600030, CODE_FOR_vec_shr_v8qi },
  { 0x15600031, CODE_FOR_vec_shr_v4hi },
  { 0x15600032, CODE_FOR_vec_shr_v2si },
  { 0x15d00030, CODE_FOR_vec_unpacks_hi_v8qi },
  { 0x15d00031, CODE_FOR_vec_unpacks_hi_v4hi },
  { 0x15d00033, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0x15d00034, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0x15d00035, CODE_FOR_vec_unpacks_hi_v4si },
  { 0x15d00042, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0x15e00030, CODE_FOR_vec_unpacks_lo_v8qi },
  { 0x15e00031, CODE_FOR_vec_unpacks_lo_v4hi },
  { 0x15e00033, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0x15e00034, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0x15e00035, CODE_FOR_vec_unpacks_lo_v4si },
  { 0x15e00042, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0x16300030, CODE_FOR_vec_unpacku_hi_v8qi },
  { 0x16300031, CODE_FOR_vec_unpacku_hi_v4hi },
  { 0x16300033, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0x16300034, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0x16300035, CODE_FOR_vec_unpacku_hi_v4si },
  { 0x16400030, CODE_FOR_vec_unpacku_lo_v8qi },
  { 0x16400031, CODE_FOR_vec_unpacku_lo_v4hi },
  { 0x16400033, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0x16400034, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0x16400035, CODE_FOR_vec_unpacku_lo_v4si },
  { 0x19200009, CODE_FOR_sync_addqi },
  { 0x1920000a, CODE_FOR_sync_addhi },
  { 0x1920000b, CODE_FOR_sync_addsi },
  { 0x1920000c, CODE_FOR_sync_adddi },
  { 0x19300009, CODE_FOR_sync_andqi },
  { 0x1930000a, CODE_FOR_sync_andhi },
  { 0x1930000b, CODE_FOR_sync_andsi },
  { 0x1930000c, CODE_FOR_sync_anddi },
  { 0x19400009, CODE_FOR_sync_iorqi },
  { 0x1940000a, CODE_FOR_sync_iorhi },
  { 0x1940000b, CODE_FOR_sync_iorsi },
  { 0x1940000c, CODE_FOR_sync_iordi },
  { 0x19600009, CODE_FOR_sync_nandqi },
  { 0x1960000a, CODE_FOR_sync_nandhi },
  { 0x1960000b, CODE_FOR_sync_nandsi },
  { 0x1960000c, CODE_FOR_sync_nanddi },
  { 0x19700009, CODE_FOR_sync_subqi },
  { 0x1970000a, CODE_FOR_sync_subhi },
  { 0x1970000b, CODE_FOR_sync_subsi },
  { 0x1970000c, CODE_FOR_sync_subdi },
  { 0x19800009, CODE_FOR_sync_xorqi },
  { 0x1980000a, CODE_FOR_sync_xorhi },
  { 0x1980000b, CODE_FOR_sync_xorsi },
  { 0x1980000c, CODE_FOR_sync_xordi },
  { 0x1a00000b, CODE_FOR_atomic_compare_and_swapsi },
  { 0x1a00000c, CODE_FOR_atomic_compare_and_swapdi },
  { 0x1a10000b, CODE_FOR_atomic_exchangesi },
  { 0x1a10000c, CODE_FOR_atomic_exchangedi },
  { 0x1a20000b, CODE_FOR_atomic_fetch_addsi },
  { 0x1a20000c, CODE_FOR_atomic_fetch_adddi },
  { 0x1b70000b, CODE_FOR_get_thread_pointersi },
  { 0x1b70000c, CODE_FOR_get_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_truncdiqi2;
  ena[8] = HAVE_truncdihi2;
  ena[9] = HAVE_truncdisi2;
  ena[10] = HAVE_truncdfsf2;
  ena[11] = HAVE_zero_extendqihi2;
  ena[12] = HAVE_zero_extendqisi2;
  ena[13] = HAVE_zero_extendqidi2;
  ena[14] = HAVE_zero_extendhisi2;
  ena[15] = HAVE_zero_extendhidi2;
  ena[16] = HAVE_zero_extendsidi2;
  ena[17] = HAVE_floatsisf2;
  ena[18] = HAVE_floatsidf2;
  ena[19] = HAVE_floatdisf2;
  ena[20] = HAVE_floatdidf2;
  ena[21] = HAVE_floatv4siv4sf2;
  ena[22] = HAVE_floatv2div2df2;
  ena[23] = HAVE_floatunsv4siv4sf2;
  ena[24] = HAVE_floatunsv2div2df2;
  ena[25] = HAVE_fix_truncsfsi2;
  ena[26] = HAVE_fix_truncsfdi2;
  ena[27] = HAVE_fix_truncdfsi2;
  ena[28] = HAVE_fix_truncdfdi2;
  ena[29] = HAVE_fix_truncv4sfv4si2;
  ena[30] = HAVE_fix_truncv2dfv2di2;
  ena[31] = HAVE_fixuns_truncsfsi2;
  ena[32] = HAVE_fixuns_truncsfdi2;
  ena[33] = HAVE_fixuns_truncdfsi2;
  ena[34] = HAVE_fixuns_truncdfdi2;
  ena[35] = HAVE_fixuns_truncv4sfv4si2;
  ena[36] = HAVE_fixuns_truncv2dfv2di2;
  ena[37] = HAVE_mulsidi3;
  ena[38] = HAVE_mulditi3;
  ena[39] = HAVE_umulsidi3;
  ena[40] = HAVE_umulditi3;
  ena[41] = HAVE_maddsidi4;
  ena[42] = HAVE_umaddsidi4;
  ena[43] = HAVE_ssmaddsqdq4;
  ena[44] = HAVE_msubsidi4;
  ena[45] = HAVE_umsubsidi4;
  ena[46] = HAVE_ssmsubsqdq4;
  ena[47] = HAVE_vcond_mask_v16qiv16qi;
  ena[48] = HAVE_vcond_mask_v8hiv16qi;
  ena[49] = HAVE_vcond_mask_v4siv16qi;
  ena[50] = HAVE_vcond_mask_v2div16qi;
  ena[51] = HAVE_vcond_mask_v4sfv16qi;
  ena[52] = HAVE_vcond_mask_v2dfv16qi;
  ena[53] = HAVE_vcond_mask_v16qiv8hi;
  ena[54] = HAVE_vcond_mask_v8hiv8hi;
  ena[55] = HAVE_vcond_mask_v4siv8hi;
  ena[56] = HAVE_vcond_mask_v2div8hi;
  ena[57] = HAVE_vcond_mask_v4sfv8hi;
  ena[58] = HAVE_vcond_mask_v2dfv8hi;
  ena[59] = HAVE_vcond_mask_v16qiv4si;
  ena[60] = HAVE_vcond_mask_v8hiv4si;
  ena[61] = HAVE_vcond_mask_v4siv4si;
  ena[62] = HAVE_vcond_mask_v2div4si;
  ena[63] = HAVE_vcond_mask_v4sfv4si;
  ena[64] = HAVE_vcond_mask_v2dfv4si;
  ena[65] = HAVE_vcond_mask_v16qiv2di;
  ena[66] = HAVE_vcond_mask_v8hiv2di;
  ena[67] = HAVE_vcond_mask_v4siv2di;
  ena[68] = HAVE_vcond_mask_v2div2di;
  ena[69] = HAVE_vcond_mask_v4sfv2di;
  ena[70] = HAVE_vcond_mask_v2dfv2di;
  ena[71] = HAVE_vec_cmpv16qiv16qi;
  ena[72] = HAVE_vec_cmpv8hiv8hi;
  ena[73] = HAVE_vec_cmpv4siv4si;
  ena[74] = HAVE_vec_cmpv4sfv4si;
  ena[75] = HAVE_vec_cmpv2div2di;
  ena[76] = HAVE_vec_cmpv2dfv2di;
  ena[77] = HAVE_vec_cmpuv16qiv16qi;
  ena[78] = HAVE_vec_cmpuv8hiv8hi;
  ena[79] = HAVE_vec_cmpuv4siv4si;
  ena[80] = HAVE_vec_cmpuv2div2di;
  ena[81] = HAVE_vec_extractv16qiqi;
  ena[82] = HAVE_vec_extractv8hihi;
  ena[83] = HAVE_vec_extractv4sisi;
  ena[84] = HAVE_vec_extractv2didi;
  ena[85] = HAVE_vec_extractv2sfsf;
  ena[86] = HAVE_vec_extractv4sfsf;
  ena[87] = HAVE_vec_extractv2dfdf;
  ena[88] = HAVE_vec_initv8qiqi;
  ena[89] = HAVE_vec_initv16qiqi;
  ena[90] = HAVE_vec_initv4hihi;
  ena[91] = HAVE_vec_initv8hihi;
  ena[92] = HAVE_vec_initv2sisi;
  ena[93] = HAVE_vec_initv4sisi;
  ena[94] = HAVE_vec_initv2didi;
  ena[95] = HAVE_vec_initv2sfsf;
  ena[96] = HAVE_vec_initv4sfsf;
  ena[97] = HAVE_vec_initv2dfdf;
  ena[98] = HAVE_sdot_prodv2siv4hi;
  ena[99] = HAVE_addsi3;
  ena[100] = HAVE_adddi3;
  ena[101] = HAVE_addqq3;
  ena[102] = HAVE_addhq3;
  ena[103] = HAVE_addsq3;
  ena[104] = HAVE_adddq3;
  ena[105] = HAVE_adduqq3;
  ena[106] = HAVE_adduhq3;
  ena[107] = HAVE_addusq3;
  ena[108] = HAVE_addudq3;
  ena[109] = HAVE_addha3;
  ena[110] = HAVE_addsa3;
  ena[111] = HAVE_addda3;
  ena[112] = HAVE_adduha3;
  ena[113] = HAVE_addusa3;
  ena[114] = HAVE_adduda3;
  ena[115] = HAVE_addsf3;
  ena[116] = HAVE_adddf3;
  ena[117] = HAVE_addv4qi3;
  ena[118] = HAVE_addv2hi3;
  ena[119] = HAVE_addv8qi3;
  ena[120] = HAVE_addv4hi3;
  ena[121] = HAVE_addv2si3;
  ena[122] = HAVE_addv16qi3;
  ena[123] = HAVE_addv8hi3;
  ena[124] = HAVE_addv4si3;
  ena[125] = HAVE_addv2di3;
  ena[126] = HAVE_addv2sf3;
  ena[127] = HAVE_addv4sf3;
  ena[128] = HAVE_addv2df3;
  ena[129] = HAVE_ssaddhq3;
  ena[130] = HAVE_ssaddsq3;
  ena[131] = HAVE_ssaddha3;
  ena[132] = HAVE_ssaddsa3;
  ena[133] = HAVE_ssaddv8qi3;
  ena[134] = HAVE_ssaddv4hi3;
  ena[135] = HAVE_ssaddv16qi3;
  ena[136] = HAVE_ssaddv8hi3;
  ena[137] = HAVE_ssaddv4si3;
  ena[138] = HAVE_ssaddv2di3;
  ena[139] = HAVE_ssaddv2hq3;
  ena[140] = HAVE_ssaddv2ha3;
  ena[141] = HAVE_usadduqq3;
  ena[142] = HAVE_usadduhq3;
  ena[143] = HAVE_usadduha3;
  ena[144] = HAVE_usaddv8qi3;
  ena[145] = HAVE_usaddv4hi3;
  ena[146] = HAVE_usaddv16qi3;
  ena[147] = HAVE_usaddv8hi3;
  ena[148] = HAVE_usaddv4si3;
  ena[149] = HAVE_usaddv2di3;
  ena[150] = HAVE_usaddv4uqq3;
  ena[151] = HAVE_usaddv2uhq3;
  ena[152] = HAVE_usaddv2uha3;
  ena[153] = HAVE_subsi3;
  ena[154] = HAVE_subdi3;
  ena[155] = HAVE_subqq3;
  ena[156] = HAVE_subhq3;
  ena[157] = HAVE_subsq3;
  ena[158] = HAVE_subdq3;
  ena[159] = HAVE_subuqq3;
  ena[160] = HAVE_subuhq3;
  ena[161] = HAVE_subusq3;
  ena[162] = HAVE_subudq3;
  ena[163] = HAVE_subha3;
  ena[164] = HAVE_subsa3;
  ena[165] = HAVE_subda3;
  ena[166] = HAVE_subuha3;
  ena[167] = HAVE_subusa3;
  ena[168] = HAVE_subuda3;
  ena[169] = HAVE_subsf3;
  ena[170] = HAVE_subdf3;
  ena[171] = HAVE_subv4qi3;
  ena[172] = HAVE_subv2hi3;
  ena[173] = HAVE_subv8qi3;
  ena[174] = HAVE_subv4hi3;
  ena[175] = HAVE_subv2si3;
  ena[176] = HAVE_subv16qi3;
  ena[177] = HAVE_subv8hi3;
  ena[178] = HAVE_subv4si3;
  ena[179] = HAVE_subv2di3;
  ena[180] = HAVE_subv2sf3;
  ena[181] = HAVE_subv4sf3;
  ena[182] = HAVE_subv2df3;
  ena[183] = HAVE_sssubhq3;
  ena[184] = HAVE_sssubsq3;
  ena[185] = HAVE_sssubha3;
  ena[186] = HAVE_sssubsa3;
  ena[187] = HAVE_sssubv8qi3;
  ena[188] = HAVE_sssubv4hi3;
  ena[189] = HAVE_sssubv2hq3;
  ena[190] = HAVE_sssubv2ha3;
  ena[191] = HAVE_ussubuqq3;
  ena[192] = HAVE_ussubuhq3;
  ena[193] = HAVE_ussubuha3;
  ena[194] = HAVE_ussubv8qi3;
  ena[195] = HAVE_ussubv4hi3;
  ena[196] = HAVE_ussubv4uqq3;
  ena[197] = HAVE_ussubv2uhq3;
  ena[198] = HAVE_ussubv2uha3;
  ena[199] = HAVE_mulsi3;
  ena[200] = HAVE_muldi3;
  ena[201] = HAVE_mulsf3;
  ena[202] = HAVE_muldf3;
  ena[203] = HAVE_mulv2hi3;
  ena[204] = HAVE_mulv4hi3;
  ena[205] = HAVE_mulv16qi3;
  ena[206] = HAVE_mulv8hi3;
  ena[207] = HAVE_mulv4si3;
  ena[208] = HAVE_mulv2di3;
  ena[209] = HAVE_mulv2sf3;
  ena[210] = HAVE_mulv4sf3;
  ena[211] = HAVE_mulv2df3;
  ena[212] = HAVE_ssmulhq3;
  ena[213] = HAVE_ssmulsq3;
  ena[214] = HAVE_ssmulv2hq3;
  ena[215] = HAVE_divsi3;
  ena[216] = HAVE_divdi3;
  ena[217] = HAVE_divsf3;
  ena[218] = HAVE_divdf3;
  ena[219] = HAVE_divv16qi3;
  ena[220] = HAVE_divv8hi3;
  ena[221] = HAVE_divv4si3;
  ena[222] = HAVE_divv2di3;
  ena[223] = HAVE_divv2sf3;
  ena[224] = HAVE_divv4sf3;
  ena[225] = HAVE_divv2df3;
  ena[226] = HAVE_udivsi3;
  ena[227] = HAVE_udivdi3;
  ena[228] = HAVE_udivv16qi3;
  ena[229] = HAVE_udivv8hi3;
  ena[230] = HAVE_udivv4si3;
  ena[231] = HAVE_udivv2di3;
  ena[232] = HAVE_divmodsi4;
  ena[233] = HAVE_divmoddi4;
  ena[234] = HAVE_udivmodsi4;
  ena[235] = HAVE_udivmoddi4;
  ena[236] = HAVE_modsi3;
  ena[237] = HAVE_moddi3;
  ena[238] = HAVE_modv16qi3;
  ena[239] = HAVE_modv8hi3;
  ena[240] = HAVE_modv4si3;
  ena[241] = HAVE_modv2di3;
  ena[242] = HAVE_umodsi3;
  ena[243] = HAVE_umoddi3;
  ena[244] = HAVE_umodv16qi3;
  ena[245] = HAVE_umodv8hi3;
  ena[246] = HAVE_umodv4si3;
  ena[247] = HAVE_umodv2di3;
  ena[248] = HAVE_andsi3;
  ena[249] = HAVE_anddi3;
  ena[250] = HAVE_andv8qi3;
  ena[251] = HAVE_andv4hi3;
  ena[252] = HAVE_andv2si3;
  ena[253] = HAVE_andv16qi3;
  ena[254] = HAVE_andv8hi3;
  ena[255] = HAVE_andv4si3;
  ena[256] = HAVE_andv2di3;
  ena[257] = HAVE_iorsi3;
  ena[258] = HAVE_iordi3;
  ena[259] = HAVE_iorv8qi3;
  ena[260] = HAVE_iorv4hi3;
  ena[261] = HAVE_iorv2si3;
  ena[262] = HAVE_iorv16qi3;
  ena[263] = HAVE_iorv8hi3;
  ena[264] = HAVE_iorv4si3;
  ena[265] = HAVE_iorv2di3;
  ena[266] = HAVE_xorsi3;
  ena[267] = HAVE_xordi3;
  ena[268] = HAVE_xorv8qi3;
  ena[269] = HAVE_xorv4hi3;
  ena[270] = HAVE_xorv2si3;
  ena[271] = HAVE_xorv16qi3;
  ena[272] = HAVE_xorv8hi3;
  ena[273] = HAVE_xorv4si3;
  ena[274] = HAVE_xorv2di3;
  ena[275] = HAVE_ashlsi3;
  ena[276] = HAVE_ashldi3;
  ena[277] = HAVE_ashlv4hi3;
  ena[278] = HAVE_ashlv2si3;
  ena[279] = HAVE_ashrsi3;
  ena[280] = HAVE_ashrdi3;
  ena[281] = HAVE_ashrv4hi3;
  ena[282] = HAVE_ashrv2si3;
  ena[283] = HAVE_lshrsi3;
  ena[284] = HAVE_lshrdi3;
  ena[285] = HAVE_lshrv4hi3;
  ena[286] = HAVE_lshrv2si3;
  ena[287] = HAVE_rotrsi3;
  ena[288] = HAVE_rotrdi3;
  ena[289] = HAVE_vashlv16qi3;
  ena[290] = HAVE_vashlv8hi3;
  ena[291] = HAVE_vashlv4si3;
  ena[292] = HAVE_vashlv2di3;
  ena[293] = HAVE_vashrv16qi3;
  ena[294] = HAVE_vashrv8hi3;
  ena[295] = HAVE_vashrv4si3;
  ena[296] = HAVE_vashrv2di3;
  ena[297] = HAVE_vlshrv16qi3;
  ena[298] = HAVE_vlshrv8hi3;
  ena[299] = HAVE_vlshrv4si3;
  ena[300] = HAVE_vlshrv2di3;
  ena[301] = HAVE_sminsf3;
  ena[302] = HAVE_smindf3;
  ena[303] = HAVE_sminv8qi3;
  ena[304] = HAVE_sminv4hi3;
  ena[305] = HAVE_sminv2si3;
  ena[306] = HAVE_sminv16qi3;
  ena[307] = HAVE_sminv8hi3;
  ena[308] = HAVE_sminv4si3;
  ena[309] = HAVE_sminv2di3;
  ena[310] = HAVE_sminv2sf3;
  ena[311] = HAVE_sminv4sf3;
  ena[312] = HAVE_sminv2df3;
  ena[313] = HAVE_smaxsf3;
  ena[314] = HAVE_smaxdf3;
  ena[315] = HAVE_smaxv8qi3;
  ena[316] = HAVE_smaxv4hi3;
  ena[317] = HAVE_smaxv2si3;
  ena[318] = HAVE_smaxv16qi3;
  ena[319] = HAVE_smaxv8hi3;
  ena[320] = HAVE_smaxv4si3;
  ena[321] = HAVE_smaxv2di3;
  ena[322] = HAVE_smaxv2sf3;
  ena[323] = HAVE_smaxv4sf3;
  ena[324] = HAVE_smaxv2df3;
  ena[325] = HAVE_uminv8qi3;
  ena[326] = HAVE_uminv16qi3;
  ena[327] = HAVE_uminv8hi3;
  ena[328] = HAVE_uminv4si3;
  ena[329] = HAVE_uminv2di3;
  ena[330] = HAVE_umaxv8qi3;
  ena[331] = HAVE_umaxv16qi3;
  ena[332] = HAVE_umaxv8hi3;
  ena[333] = HAVE_umaxv4si3;
  ena[334] = HAVE_umaxv2di3;
  ena[335] = HAVE_negsi2;
  ena[336] = HAVE_negdi2;
  ena[337] = HAVE_negsf2;
  ena[338] = HAVE_negdf2;
  ena[339] = HAVE_negv16qi2;
  ena[340] = HAVE_negv8hi2;
  ena[341] = HAVE_negv4si2;
  ena[342] = HAVE_negv2di2;
  ena[343] = HAVE_negv2sf2;
  ena[344] = HAVE_negv4sf2;
  ena[345] = HAVE_negv2df2;
  ena[346] = HAVE_abssf2;
  ena[347] = HAVE_absdf2;
  ena[348] = HAVE_absv16qi2;
  ena[349] = HAVE_absv8hi2;
  ena[350] = HAVE_absv4si2;
  ena[351] = HAVE_absv2di2;
  ena[352] = HAVE_absv2sf2;
  ena[353] = HAVE_one_cmplsi2;
  ena[354] = HAVE_one_cmpldi2;
  ena[355] = HAVE_one_cmplv8qi2;
  ena[356] = HAVE_one_cmplv4hi2;
  ena[357] = HAVE_one_cmplv2si2;
  ena[358] = HAVE_one_cmplv16qi2;
  ena[359] = HAVE_one_cmplv8hi2;
  ena[360] = HAVE_one_cmplv4si2;
  ena[361] = HAVE_one_cmplv2di2;
  ena[362] = HAVE_bswaphi2;
  ena[363] = HAVE_bswapsi2;
  ena[364] = HAVE_bswapdi2;
  ena[365] = HAVE_clzsi2;
  ena[366] = HAVE_clzdi2;
  ena[367] = HAVE_clzv16qi2;
  ena[368] = HAVE_clzv8hi2;
  ena[369] = HAVE_clzv4si2;
  ena[370] = HAVE_clzv2di2;
  ena[371] = HAVE_ctzsi2;
  ena[372] = HAVE_ctzdi2;
  ena[373] = HAVE_popcountsi2;
  ena[374] = HAVE_popcountdi2;
  ena[375] = HAVE_popcountv16qi2;
  ena[376] = HAVE_popcountv8hi2;
  ena[377] = HAVE_popcountv4si2;
  ena[378] = HAVE_popcountv2di2;
  ena[379] = HAVE_sqrtsf2;
  ena[380] = HAVE_sqrtdf2;
  ena[381] = HAVE_sqrtv2sf2;
  ena[382] = HAVE_sqrtv4sf2;
  ena[383] = HAVE_sqrtv2df2;
  ena[384] = HAVE_sync_old_addqi;
  ena[385] = HAVE_sync_old_addhi;
  ena[386] = HAVE_sync_old_addsi;
  ena[387] = HAVE_sync_old_adddi;
  ena[388] = HAVE_sync_old_subqi;
  ena[389] = HAVE_sync_old_subhi;
  ena[390] = HAVE_sync_old_subsi;
  ena[391] = HAVE_sync_old_subdi;
  ena[392] = HAVE_sync_old_iorqi;
  ena[393] = HAVE_sync_old_iorhi;
  ena[394] = HAVE_sync_old_iorsi;
  ena[395] = HAVE_sync_old_iordi;
  ena[396] = HAVE_sync_old_andqi;
  ena[397] = HAVE_sync_old_andhi;
  ena[398] = HAVE_sync_old_andsi;
  ena[399] = HAVE_sync_old_anddi;
  ena[400] = HAVE_sync_old_xorqi;
  ena[401] = HAVE_sync_old_xorhi;
  ena[402] = HAVE_sync_old_xorsi;
  ena[403] = HAVE_sync_old_xordi;
  ena[404] = HAVE_sync_old_nandqi;
  ena[405] = HAVE_sync_old_nandhi;
  ena[406] = HAVE_sync_old_nandsi;
  ena[407] = HAVE_sync_old_nanddi;
  ena[408] = HAVE_sync_new_addqi;
  ena[409] = HAVE_sync_new_addhi;
  ena[410] = HAVE_sync_new_addsi;
  ena[411] = HAVE_sync_new_adddi;
  ena[412] = HAVE_sync_new_subqi;
  ena[413] = HAVE_sync_new_subhi;
  ena[414] = HAVE_sync_new_subsi;
  ena[415] = HAVE_sync_new_subdi;
  ena[416] = HAVE_sync_new_iorqi;
  ena[417] = HAVE_sync_new_iorhi;
  ena[418] = HAVE_sync_new_iorsi;
  ena[419] = HAVE_sync_new_iordi;
  ena[420] = HAVE_sync_new_andqi;
  ena[421] = HAVE_sync_new_andhi;
  ena[422] = HAVE_sync_new_andsi;
  ena[423] = HAVE_sync_new_anddi;
  ena[424] = HAVE_sync_new_xorqi;
  ena[425] = HAVE_sync_new_xorhi;
  ena[426] = HAVE_sync_new_xorsi;
  ena[427] = HAVE_sync_new_xordi;
  ena[428] = HAVE_sync_new_nandqi;
  ena[429] = HAVE_sync_new_nandhi;
  ena[430] = HAVE_sync_new_nandsi;
  ena[431] = HAVE_sync_new_nanddi;
  ena[432] = HAVE_sync_compare_and_swapqi;
  ena[433] = HAVE_sync_compare_and_swaphi;
  ena[434] = HAVE_sync_compare_and_swapsi;
  ena[435] = HAVE_sync_compare_and_swapdi;
  ena[436] = HAVE_sync_lock_test_and_setqi;
  ena[437] = HAVE_sync_lock_test_and_sethi;
  ena[438] = HAVE_sync_lock_test_and_setsi;
  ena[439] = HAVE_sync_lock_test_and_setdi;
  ena[440] = HAVE_movccf;
  ena[441] = HAVE_movqi;
  ena[442] = HAVE_movhi;
  ena[443] = HAVE_movsi;
  ena[444] = HAVE_movdi;
  ena[445] = HAVE_movti;
  ena[446] = HAVE_movsf;
  ena[447] = HAVE_movdf;
  ena[448] = HAVE_movtf;
  ena[449] = HAVE_movv4qi;
  ena[450] = HAVE_movv2hi;
  ena[451] = HAVE_movv8qi;
  ena[452] = HAVE_movv4hi;
  ena[453] = HAVE_movv2si;
  ena[454] = HAVE_movv16qi;
  ena[455] = HAVE_movv8hi;
  ena[456] = HAVE_movv4si;
  ena[457] = HAVE_movv2di;
  ena[458] = HAVE_movv4qq;
  ena[459] = HAVE_movv2hq;
  ena[460] = HAVE_movv4uqq;
  ena[461] = HAVE_movv2uhq;
  ena[462] = HAVE_movv2ha;
  ena[463] = HAVE_movv2uha;
  ena[464] = HAVE_movv2sf;
  ena[465] = HAVE_movv4sf;
  ena[466] = HAVE_movv2df;
  ena[467] = HAVE_movmisalignhi;
  ena[468] = HAVE_movmisalignsi;
  ena[469] = HAVE_movmisalignsf;
  ena[470] = HAVE_movmisaligndf;
  ena[471] = HAVE_movmisalignv16qi;
  ena[472] = HAVE_movmisalignv8hi;
  ena[473] = HAVE_movmisalignv4si;
  ena[474] = HAVE_movmisalignv2di;
  ena[475] = HAVE_movmisalignv4sf;
  ena[476] = HAVE_movmisalignv2df;
  ena[477] = HAVE_insvsi;
  ena[478] = HAVE_insvdi;
  ena[479] = HAVE_extvsi;
  ena[480] = HAVE_extvdi;
  ena[481] = HAVE_extzvsi;
  ena[482] = HAVE_extzvdi;
  ena[483] = HAVE_insvmisalignsi;
  ena[484] = HAVE_insvmisaligndi;
  ena[485] = HAVE_extvmisalignsi;
  ena[486] = HAVE_extvmisaligndi;
  ena[487] = HAVE_extzvmisalignsi;
  ena[488] = HAVE_extzvmisaligndi;
  ena[489] = HAVE_cbranchsi4;
  ena[490] = HAVE_cbranchdi4;
  ena[491] = HAVE_cbranchsf4;
  ena[492] = HAVE_cbranchdf4;
  ena[493] = HAVE_movsicc;
  ena[494] = HAVE_movdicc;
  ena[495] = HAVE_movsfcc;
  ena[496] = HAVE_movdfcc;
  ena[497] = HAVE_movv2sfcc;
  ena[498] = HAVE_cstoresi4;
  ena[499] = HAVE_cstoredi4;
  ena[500] = HAVE_ctrapsi4;
  ena[501] = HAVE_ctrapdi4;
  ena[502] = HAVE_smulsi3_highpart;
  ena[503] = HAVE_smuldi3_highpart;
  ena[504] = HAVE_smulv4hi3_highpart;
  ena[505] = HAVE_umulsi3_highpart;
  ena[506] = HAVE_umuldi3_highpart;
  ena[507] = HAVE_umulv4hi3_highpart;
  ena[508] = HAVE_cpymemsi;
  ena[509] = HAVE_fmasf4;
  ena[510] = HAVE_fmadf4;
  ena[511] = HAVE_fmav2sf4;
  ena[512] = HAVE_fmav4sf4;
  ena[513] = HAVE_fmav2df4;
  ena[514] = HAVE_fmssf4;
  ena[515] = HAVE_fmsdf4;
  ena[516] = HAVE_fmsv2sf4;
  ena[517] = HAVE_fnmasf4;
  ena[518] = HAVE_fnmadf4;
  ena[519] = HAVE_fnmav2sf4;
  ena[520] = HAVE_fnmav4sf4;
  ena[521] = HAVE_fnmav2df4;
  ena[522] = HAVE_fnmssf4;
  ena[523] = HAVE_fnmsdf4;
  ena[524] = HAVE_fnmsv2sf4;
  ena[525] = HAVE_rintsf2;
  ena[526] = HAVE_rintdf2;
  ena[527] = HAVE_fmaxsf3;
  ena[528] = HAVE_fmaxdf3;
  ena[529] = HAVE_fminsf3;
  ena[530] = HAVE_fmindf3;
  ena[531] = HAVE_reduc_smax_scal_v8qi;
  ena[532] = HAVE_reduc_smax_scal_v4hi;
  ena[533] = HAVE_reduc_smax_scal_v2si;
  ena[534] = HAVE_reduc_smax_scal_v16qi;
  ena[535] = HAVE_reduc_smax_scal_v8hi;
  ena[536] = HAVE_reduc_smax_scal_v4si;
  ena[537] = HAVE_reduc_smax_scal_v2di;
  ena[538] = HAVE_reduc_smax_scal_v2sf;
  ena[539] = HAVE_reduc_smax_scal_v4sf;
  ena[540] = HAVE_reduc_smax_scal_v2df;
  ena[541] = HAVE_reduc_smin_scal_v8qi;
  ena[542] = HAVE_reduc_smin_scal_v4hi;
  ena[543] = HAVE_reduc_smin_scal_v2si;
  ena[544] = HAVE_reduc_smin_scal_v16qi;
  ena[545] = HAVE_reduc_smin_scal_v8hi;
  ena[546] = HAVE_reduc_smin_scal_v4si;
  ena[547] = HAVE_reduc_smin_scal_v2di;
  ena[548] = HAVE_reduc_smin_scal_v2sf;
  ena[549] = HAVE_reduc_smin_scal_v4sf;
  ena[550] = HAVE_reduc_smin_scal_v2df;
  ena[551] = HAVE_reduc_plus_scal_v8qi;
  ena[552] = HAVE_reduc_plus_scal_v4hi;
  ena[553] = HAVE_reduc_plus_scal_v2si;
  ena[554] = HAVE_reduc_plus_scal_v16qi;
  ena[555] = HAVE_reduc_plus_scal_v8hi;
  ena[556] = HAVE_reduc_plus_scal_v4si;
  ena[557] = HAVE_reduc_plus_scal_v2di;
  ena[558] = HAVE_reduc_plus_scal_v2sf;
  ena[559] = HAVE_reduc_plus_scal_v4sf;
  ena[560] = HAVE_reduc_plus_scal_v2df;
  ena[561] = HAVE_reduc_umax_scal_v8qi;
  ena[562] = HAVE_reduc_umax_scal_v16qi;
  ena[563] = HAVE_reduc_umax_scal_v8hi;
  ena[564] = HAVE_reduc_umax_scal_v4si;
  ena[565] = HAVE_reduc_umax_scal_v2di;
  ena[566] = HAVE_reduc_umin_scal_v8qi;
  ena[567] = HAVE_reduc_umin_scal_v16qi;
  ena[568] = HAVE_reduc_umin_scal_v8hi;
  ena[569] = HAVE_reduc_umin_scal_v4si;
  ena[570] = HAVE_reduc_umin_scal_v2di;
  ena[571] = HAVE_reduc_and_scal_v16qi;
  ena[572] = HAVE_reduc_and_scal_v8hi;
  ena[573] = HAVE_reduc_and_scal_v4si;
  ena[574] = HAVE_reduc_and_scal_v2di;
  ena[575] = HAVE_reduc_ior_scal_v16qi;
  ena[576] = HAVE_reduc_ior_scal_v8hi;
  ena[577] = HAVE_reduc_ior_scal_v4si;
  ena[578] = HAVE_reduc_ior_scal_v2di;
  ena[579] = HAVE_reduc_xor_scal_v16qi;
  ena[580] = HAVE_reduc_xor_scal_v8hi;
  ena[581] = HAVE_reduc_xor_scal_v4si;
  ena[582] = HAVE_reduc_xor_scal_v2di;
  ena[583] = HAVE_vec_pack_ssat_v4hi;
  ena[584] = HAVE_vec_pack_ssat_v2si;
  ena[585] = HAVE_vec_pack_trunc_v8hi;
  ena[586] = HAVE_vec_pack_trunc_v4si;
  ena[587] = HAVE_vec_pack_trunc_v2di;
  ena[588] = HAVE_vec_pack_trunc_v2df;
  ena[589] = HAVE_vec_pack_usat_v4hi;
  ena[590] = HAVE_vec_permv16qi;
  ena[591] = HAVE_vec_permv8hi;
  ena[592] = HAVE_vec_permv4si;
  ena[593] = HAVE_vec_permv2di;
  ena[594] = HAVE_vec_permv4sf;
  ena[595] = HAVE_vec_permv2df;
  ena[596] = HAVE_vec_setv4hi;
  ena[597] = HAVE_vec_setv16qi;
  ena[598] = HAVE_vec_setv8hi;
  ena[599] = HAVE_vec_setv4si;
  ena[600] = HAVE_vec_setv2di;
  ena[601] = HAVE_vec_setv2sf;
  ena[602] = HAVE_vec_setv4sf;
  ena[603] = HAVE_vec_setv2df;
  ena[604] = HAVE_vec_shl_di;
  ena[605] = HAVE_vec_shl_v8qi;
  ena[606] = HAVE_vec_shl_v4hi;
  ena[607] = HAVE_vec_shl_v2si;
  ena[608] = HAVE_vec_shr_di;
  ena[609] = HAVE_vec_shr_v8qi;
  ena[610] = HAVE_vec_shr_v4hi;
  ena[611] = HAVE_vec_shr_v2si;
  ena[612] = HAVE_vec_unpacks_hi_v8qi;
  ena[613] = HAVE_vec_unpacks_hi_v4hi;
  ena[614] = HAVE_vec_unpacks_hi_v16qi;
  ena[615] = HAVE_vec_unpacks_hi_v8hi;
  ena[616] = HAVE_vec_unpacks_hi_v4si;
  ena[617] = HAVE_vec_unpacks_hi_v4sf;
  ena[618] = HAVE_vec_unpacks_lo_v8qi;
  ena[619] = HAVE_vec_unpacks_lo_v4hi;
  ena[620] = HAVE_vec_unpacks_lo_v16qi;
  ena[621] = HAVE_vec_unpacks_lo_v8hi;
  ena[622] = HAVE_vec_unpacks_lo_v4si;
  ena[623] = HAVE_vec_unpacks_lo_v4sf;
  ena[624] = HAVE_vec_unpacku_hi_v8qi;
  ena[625] = HAVE_vec_unpacku_hi_v4hi;
  ena[626] = HAVE_vec_unpacku_hi_v16qi;
  ena[627] = HAVE_vec_unpacku_hi_v8hi;
  ena[628] = HAVE_vec_unpacku_hi_v4si;
  ena[629] = HAVE_vec_unpacku_lo_v8qi;
  ena[630] = HAVE_vec_unpacku_lo_v4hi;
  ena[631] = HAVE_vec_unpacku_lo_v16qi;
  ena[632] = HAVE_vec_unpacku_lo_v8hi;
  ena[633] = HAVE_vec_unpacku_lo_v4si;
  ena[634] = HAVE_sync_addqi;
  ena[635] = HAVE_sync_addhi;
  ena[636] = HAVE_sync_addsi;
  ena[637] = HAVE_sync_adddi;
  ena[638] = HAVE_sync_andqi;
  ena[639] = HAVE_sync_andhi;
  ena[640] = HAVE_sync_andsi;
  ena[641] = HAVE_sync_anddi;
  ena[642] = HAVE_sync_iorqi;
  ena[643] = HAVE_sync_iorhi;
  ena[644] = HAVE_sync_iorsi;
  ena[645] = HAVE_sync_iordi;
  ena[646] = HAVE_sync_nandqi;
  ena[647] = HAVE_sync_nandhi;
  ena[648] = HAVE_sync_nandsi;
  ena[649] = HAVE_sync_nanddi;
  ena[650] = HAVE_sync_subqi;
  ena[651] = HAVE_sync_subhi;
  ena[652] = HAVE_sync_subsi;
  ena[653] = HAVE_sync_subdi;
  ena[654] = HAVE_sync_xorqi;
  ena[655] = HAVE_sync_xorhi;
  ena[656] = HAVE_sync_xorsi;
  ena[657] = HAVE_sync_xordi;
  ena[658] = HAVE_atomic_compare_and_swapsi;
  ena[659] = HAVE_atomic_compare_and_swapdi;
  ena[660] = HAVE_atomic_exchangesi;
  ena[661] = HAVE_atomic_exchangedi;
  ena[662] = HAVE_atomic_fetch_addsi;
  ena[663] = HAVE_atomic_fetch_adddi;
  ena[664] = HAVE_get_thread_pointersi;
  ena[665] = HAVE_get_thread_pointerdi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
  { "ustrunc", NULL },
  { "sstrunc", NULL },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  US_TRUNCATE,
  SS_TRUNCATE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

